/*
 * Copyright (C) 2013 - Gareth Llewellyn
 *
 * This file is part of the Unofficial HackedIO Android App https://github.com/NetworksAreMadeOfString/HackedIO-Android-App
 *
 * This app is unofficial. The "Hacked.io" logo is copyright (and maybe even a trademark of) Telefónica UK Limited.
 * The author of this app is not affiliated with Telefónica UK Limited, The Lab ( https://thelab.o2.com/ ) or
 * Geeks of London ( http://geeksoflondon.com/ ) although the author <strong>is</strong> an attendee.
 *
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program. If not, see <http://www.gnu.org/licenses/>
 */
package app.hacked;

import android.content.Context;
import android.content.Intent;

public class GCMIntentService extends com.google.android.gcm.GCMBaseIntentService
{
    public GCMIntentService()
    {
        super(API.SENDER_ID);
    }

    @Override
    protected void onMessage(Context context, Intent intent)
    {
        if(intent.getExtras().containsKey("type") && intent.getExtras().getString("type").equals("chat"))
        {
            Intent broadcast = new Intent();
            broadcast.setAction(ChatFragment.BROADCAST_ACTION);
            broadcast.putExtra("name",intent.getExtras().getString("name"));
            broadcast.putExtra("msg",intent.getExtras().getString("msg"));
            sendBroadcast(broadcast);
        }
    }

    @Override
    protected void onError(Context context, String s) {

    }

    @Override
    protected void onRegistered(Context context, String s)
    {

    }

    @Override
    protected void onUnregistered(Context context, String s) {

    }
}
