package app.hacked;

import android.util.Log;
import org.json.JSONArray;
import org.json.JSONObject;

import java.util.ArrayList;

/**
 * Created by Gareth on 22/06/13.
 */
public class Project
{
    public int ID = 0;
    public ArrayList<TeamMember> TeamMembers = null;
    //public String TeamMembers = "";
    public String Name = "";
    public String Description = "";
    //public List<String> Technologies = null;
    public String Technologies = "";
    public String Location = "The O2";
    public int Popularity = 1;
    public String Synopsis = "";

    public Project(JSONObject projectJSON)
    {
        try
        {
            Log.e("json", projectJSON.toString(3).toString());
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }

        if(projectJSON.has("projectID"))
        {
            try
            {
                this.ID = projectJSON.getInt("projectID");
            }
            catch(Exception e)
            {
                e.printStackTrace();
            }
        }

        if(projectJSON.has("Popularity"))
        {
            try
            {
                this.Popularity = projectJSON.getInt("Popularity");
            }
            catch(Exception e)
            {
                e.printStackTrace();
            }
        }

        if(projectJSON.has("Name"))
        {
            try
            {
                this.Name = projectJSON.getString("Name");
            }
            catch(Exception e)
            {
                e.printStackTrace();
            }
        }

        if(projectJSON.has("Description"))
        {
            try
            {
                this.Description = projectJSON.getString("Description");
            }
            catch(Exception e)
            {
                e.printStackTrace();
            }
        }

        if(projectJSON.has("Synopsis"))
        {
            try
            {
                this.Synopsis = projectJSON.getString("Synopsis");
            }
            catch(Exception e)
            {
                e.printStackTrace();
            }
        }

        if(projectJSON.has("Location"))
        {
            try
            {
                this.Location = projectJSON.getString("Location");
            }
            catch(Exception e)
            {
                e.printStackTrace();
            }
        }

        if(projectJSON.has("TeamMembers"))
        {
            try
            {
                JSONArray teamMembersJSA = new JSONArray(projectJSON.getString("TeamMembers"));
                int memberLength = teamMembersJSA.length();
                if(memberLength > 0)
                {
                    TeamMembers = new ArrayList<TeamMember>();

                    for(int i = 0; i < memberLength; i++)
                    {
                        JSONObject teamMember = teamMembersJSA.getJSONObject(i);

                        TeamMembers.add(new TeamMember(teamMember.getString("name"),teamMember.getString("gravatar")));
                    }
                }
                else
                {
                    TeamMembers = null;
                }
            }
            catch(Exception e)
            {
                e.printStackTrace();
            }
        }

        if(projectJSON.has("Technologies"))
        {
            try
            {
                this.Technologies = projectJSON.getString("Technologies");
            }
            catch(Exception e)
            {
                e.printStackTrace();
            }
        }
    }

    public String getTeamMembers()
    {
        String returnString = "";
        if(null != TeamMembers && TeamMembers.size() > 0)
        {
            for(TeamMember teamMember : TeamMembers)
            {
                returnString += teamMember.Name + ", ";
            }

            return returnString.substring(0,returnString.length() -2);
        }
        else
        {
            return "No Team members listed";
        }

        //return this.TeamMembers;
    }
}
