/*
 * Copyright (C) 2013 - Gareth Llewellyn
 *
 * This file is part of the Unofficial HackedIO Android App https://github.com/NetworksAreMadeOfString/HackedIO-Android-App
 *
 * This app is unofficial. The "Hacked.io" logo is copyright (and maybe even a trademark of) Telefónica UK Limited.
 * The author of this app is not affiliated with Telefónica UK Limited, The Lab ( https://thelab.o2.com/ ) or
 * Geeks of London ( http://geeksoflondon.com/ ) although the author <strong>is</strong> an attendee.
 *
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program. If not, see <http://www.gnu.org/licenses/>
 */
package app.hacked;

import android.content.Context;
import android.graphics.Typeface;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.TextView;

import java.util.List;
import java.util.Random;

public class ProjectListAdapter extends BaseAdapter
{

    private Context context;
    private List<Project> HackedIOProjects;
    private Random r = new Random();
    private Integer[] mThumbIds = {
            R.drawable.projects_0, R.drawable.projects_1,
            R.drawable.projects_2, R.drawable.projects_3,
            R.drawable.projects_4, R.drawable.projects_5,
            R.drawable.projects_6, R.drawable.projects_7,
            R.drawable.projects_8 };

    public ProjectListAdapter(Context context, List<Project> _HackedIOProjects)
    {
        this.context = context;
        this.HackedIOProjects = _HackedIOProjects;
    }

    @Override
    public int getCount()
    {
       return HackedIOProjects.size();
    }

    @Override
    public Object getItem(int i)
    {
        return HackedIOProjects.get(i);
    }

    @Override
    public long getItemId(int i)
    {
        return i;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup viewGroup)
    {

        Project project = HackedIOProjects.get(position);
        Typeface Normal = Typeface.create("sans-serif", Typeface.NORMAL);

        if (convertView == null)
        {
            LayoutInflater inflater = (LayoutInflater) context.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
            convertView = inflater.inflate(R.layout.project_list_item, null);
        }

        TextView Title = (TextView) convertView.findViewById(R.id.Title);
        Title.setTypeface(Typeface.create("sans-serif-light", Typeface.NORMAL));
        Title.setText(project.Name);

        ((TextView) convertView.findViewById(R.id.TeamMembers)).setText(project.getTeamMembers());
        ((TextView) convertView.findViewById(R.id.TeamMembers)).setTypeface(Typeface.create("sans-serif-condensed", Typeface.NORMAL));

        ((TextView) convertView.findViewById(R.id.Description)).setText(project.Synopsis);

        ImageView Img = ((ImageView) convertView.findViewById(R.id.randomImage));
        Img.setImageResource(mThumbIds[r.nextInt(mThumbIds.length)]);
        return convertView;
    }
}
