package app.hacked;

import android.app.PendingIntent;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.SharedPreferences;
import android.nfc.NfcAdapter;
import android.nfc.Tag;
import android.nfc.tech.Ndef;
import android.nfc.tech.NdefFormatable;
import android.nfc.tech.NfcA;
import android.nfc.tech.NfcF;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.preference.PreferenceManager;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.TextView;
import android.widget.Toast;
import com.android.volley.Request;
import com.android.volley.RequestQueue;
import com.android.volley.Response;
import com.android.volley.VolleyError;
import com.android.volley.toolbox.JsonObjectRequest;
import com.android.volley.toolbox.Volley;
import com.google.example.games.basegameutils.BaseGameActivity;
import org.json.JSONObject;

/**
 * Created by Gareth on 15/07/13.
 */
public class ScavengerHunt extends BaseGameActivity implements View.OnClickListener
{
    IntentFilter[] intentFiltersArray = null;
    String[][] techListsArray;
    SharedPreferences settings = null;

    private NfcAdapter mAdapter;
    private PendingIntent pendingIntent;

    Handler tagHandler = null;
    static final int READY = 1000;
    static final int WRITE_SUCCESS = 1001;
    static final int IOEXCEPTION = 1002;
    static final int SIGNED_IN_ERROR = 1003;
    static final int TAG_IO_IN_PROGRESS = 1004;
    static final int SERVER_IO_IN_PROGRESS = 1005;
    static final int SERVER_IO_FAILURE = 1006;
    static final int COMPLETE = 1007;
    static final int SIZEERROR = 1008;

    RequestQueue queue = null;
    View progressBar = null;
    TextView totalTags = null;
    TextView acheivementsUnlocked = null;

    Integer totalTagsCount = 0;
    Integer achievementsCount = 0;

    @Override
    public void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.scavenge_activity);

        findViewById(R.id.sign_in_button).setOnClickListener(this);
        findViewById(R.id.sign_out_button).setOnClickListener(this);

        getActionBar().setTitle("NFC Scavenger Hunt!");
        getActionBar().setSubtitle("Find and scan tags to take part");

        progressBar = findViewById(R.id.progressBar);
        totalTags = (TextView) findViewById(R.id.TotalValue);
        acheivementsUnlocked = (TextView) findViewById(R.id.AcheiveValue);

        mAdapter = NfcAdapter.getDefaultAdapter(this);

        pendingIntent = PendingIntent.getActivity(this, 0, new Intent(this, getClass()).addFlags(Intent.FLAG_ACTIVITY_SINGLE_TOP), 0);

        IntentFilter ndef = new IntentFilter(NfcAdapter.ACTION_NDEF_DISCOVERED);

        try
        {
            ndef.addDataType("*/*");    /* Handles all MIME based dispatches.
                                           You should specify only the ones that you need. */
        }
        catch (IntentFilter.MalformedMimeTypeException e)
        {
            throw new RuntimeException("fail", e);
        }
        IntentFilter td = new IntentFilter(NfcAdapter.ACTION_TAG_DISCOVERED);
        intentFiltersArray = new IntentFilter[] {ndef, td};

        techListsArray = new String[][] { new String[] { NfcF.class.getName(),NfcA.class.getName(),Ndef.class.getName(), NdefFormatable.class.getName() } };

        tagHandler = new Handler()
        {
            public void handleMessage(Message msg)
            {
                switch(msg.what)
                {
                    case TAG_IO_IN_PROGRESS:
                    {
                        progressBar.setVisibility(View.VISIBLE);
                    }
                    break;

                    case COMPLETE:
                    {
                        progressBar.setVisibility(View.INVISIBLE);
                    }
                    break;

                    case SIGNED_IN_ERROR:
                    {
                        progressBar.setVisibility(View.INVISIBLE);
                        Toast.makeText(ScavengerHunt.this,"You must be signed in to play the scavenger hunt",Toast.LENGTH_SHORT).show();
                    }
                }
            }
        };

        queue = Volley.newRequestQueue(this);
        settings = PreferenceManager.getDefaultSharedPreferences(this);

        totalTags.setText(Integer.toString(settings.getInt("total_tags",0)));
        acheivementsUnlocked.setText(Integer.toString(settings.getInt("total_achieve",0)) + " / 5");
    }

    public void updateTotalTags()
    {
        SharedPreferences.Editor editor = PreferenceManager.getDefaultSharedPreferences(this).edit();
        totalTagsCount++;
        editor.putInt("total_tags",totalTagsCount);
        editor.commit();
        totalTags.setText(Integer.toString(totalTagsCount));
    }

    public void updateAchievements()
    {
        SharedPreferences.Editor editor = PreferenceManager.getDefaultSharedPreferences(this).edit();
        achievementsCount++;
        editor.putInt("total_achieve",achievementsCount);
        editor.commit();
        acheivementsUnlocked.setText(Integer.toString(achievementsCount) + " / 5");
    }

    String ByteArrayToHexString(byte [] inarray)
    {
        int i, j, in;
        String [] hex = {"0","1","2","3","4","5","6","7","8","9","A","B","C","D","E","F"};
        String out= "";

        for(j = 0 ; j < inarray.length ; ++j)
        {
            in = (int) inarray[j] & 0xff;
            i = (in >> 4) & 0x0f;
            out += hex[i];
            i = in & 0x0f;
            out += hex[i];
        }
        return out;
    }

    public void ParseTag(Tag tagFromIntent)
    {
        tagHandler.sendEmptyMessage(TAG_IO_IN_PROGRESS);
        updateTotalTags();

        if (isSignedIn())
        {
            //String tagID = new String(tagFromIntent.getId());
            String tagid = ByteArrayToHexString(tagFromIntent.getId());
            String userID = getGamesClient().getCurrentPlayerId();
            String url = "http://hackedioapp.networksaremadeofstring.co.uk/scavenge.php?tag=" + tagid + "&user=" + userID;

            Log.e("test", url);
            JsonObjectRequest jsObjRequest = new JsonObjectRequest(Request.Method.GET, url, null, new Response.Listener<JSONObject>()
            {
                @Override
                public void onResponse(JSONObject response)
                {
                    tagHandler.sendEmptyMessage(COMPLETE);
                    try
                    {
                        if(response.has("success") && response.getBoolean("success") && response.has("games"))
                        {
                            JSONObject games = response.getJSONObject("games");
                            Toast.makeText(ScavengerHunt.this,"Success!\n\nKeep going and find some more...",Toast.LENGTH_SHORT).show();
                            if(games.has("acheivement_id") && games.has("acheivement_desc"))
                            {
                                try
                                {
                                    String acheivement = games.getString("acheivement_id");
                                    getGamesClient().unlockAchievement(acheivement);

                                    //Toast.makeText(ScavengerHunt.this,games.getString("acheivement_desc"),Toast.LENGTH_SHORT).show();
                                    updateAchievements();
                                }
                                catch (Exception e)
                                {
                                    e.printStackTrace();
                                }
                            }
                        }
                        else
                        {
                            Toast.makeText(ScavengerHunt.this,"An Error Was encountered",Toast.LENGTH_SHORT).show();
                        }
                    }
                    catch(Exception e)
                    {
                        e.printStackTrace();
                        Toast.makeText(ScavengerHunt.this,"An Error Was encountered",Toast.LENGTH_SHORT).show();
                    }

                }
            }, new Response.ErrorListener()
            {

                @Override
                public void onErrorResponse(VolleyError error)
                {
                    Toast.makeText(ScavengerHunt.this,"An Error Was encountered",Toast.LENGTH_SHORT).show();
                    tagHandler.sendEmptyMessage(COMPLETE);
                }
            });

            queue.add(jsObjRequest);
        }
        else
        {
            // alternative implementation (or warn user that they must
            // sign in to use this feature)
            tagHandler.sendEmptyMessage(SIGNED_IN_ERROR);
        }
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu)
    {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.scavenge, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item)
    {
        switch (item.getItemId())
        {
            case R.id.action_leaderboard:
            {
                if (isSignedIn())
                {
                    startActivityForResult(getGamesClient().getLeaderboardIntent("CgkIg47o1I0LEAIQBg"), 1);
                }
                else
                {
                    tagHandler.sendEmptyMessage(SIGNED_IN_ERROR);
                }
                return true;
            }

            case R.id.action_achievements:
            {
                if (isSignedIn())
                {
                    startActivityForResult(getGamesClient().getAchievementsIntent(), 2);
                }
                else
                {
                    tagHandler.sendEmptyMessage(SIGNED_IN_ERROR);
                }
                return true;
            }
        }

        return false;
    }

    public void onPause()
    {
        super.onPause();

        if(mAdapter != null)
            mAdapter.disableForegroundDispatch(this);
    }

    public void onResume()
    {
        super.onResume();

        if(mAdapter != null)
            mAdapter.enableForegroundDispatch(this, pendingIntent, intentFiltersArray, techListsArray);
    }

    public void onNewIntent(Intent intent)
    {
        Tag tagFromIntent = intent.getParcelableExtra(NfcAdapter.EXTRA_TAG);
        ParseTag(tagFromIntent);
    }

    @Override
    public void onSignInFailed()
    {
        // Sign in has failed. So show the user the sign-in button.
        findViewById(R.id.sign_in_button).setVisibility(View.VISIBLE);
        findViewById(R.id.sign_out_button).setVisibility(View.GONE);
    }

    @Override
    public void onSignInSucceeded()
    {
        // show sign-out button, hide the sign-in button
        findViewById(R.id.sign_in_button).setVisibility(View.GONE);
        findViewById(R.id.sign_out_button).setVisibility(View.VISIBLE);

        // (your code here: update UI, enable functionality that depends on sign in, etc)
    }

    @Override
    public void onClick(View view)
    {
        if (view.getId() == R.id.sign_in_button) {
        // start the asynchronous sign in flow
        beginUserInitiatedSignIn();
    }
    else if (view.getId() == R.id.sign_out_button)
    {
        // sign out.
        signOut();

        // show sign-in button, hide the sign-out button
        findViewById(R.id.sign_in_button).setVisibility(View.VISIBLE);
        findViewById(R.id.sign_out_button).setVisibility(View.GONE);
    }
}
}
