/*
 * Copyright (C) 2013 - Gareth Llewellyn
 *
 * This file is part of the Unofficial HackedIO Android App https://github.com/NetworksAreMadeOfString/HackedIO-Android-App
 *
 * This app is unofficial. The "Hacked.io" logo is copyright (and maybe even a trademark of) Telefónica UK Limited.
 * The author of this app is not affiliated with Telefónica UK Limited, The Lab ( https://thelab.o2.com/ ) or
 * Geeks of London ( http://geeksoflondon.com/ ) although the author <strong>is</strong> an attendee.
 *
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program. If not, see <http://www.gnu.org/licenses/>
 */
package app.hacked;

import android.graphics.Typeface;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.text.Html;
import android.text.method.LinkMovementMethod;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

public class ScheduleItemDetailFragment extends Fragment
{
    public static final String  SCHEDULETITLE = "scheduleTitle";
    public static final String  SCHEDULEID = "scheduleID";
    public static final String  SCHEDULEFULLDATAHTML = "scheduleFullDataHTML";
    public static final String  SCHEDULESTARTTIME = "scheduleStartTime";
    public static final String  SCHEDULEDESC = "scheduleDesc";
    public static final String  ISDAYTITLE = "isDayTitle";
    public static final String  SCHEDULEENDTIME = "scheduleEndTime";
    public static final String  ARG_2PANE = "m2pane";

    private String scheduleTitle = "";
    private String scheduleID = "";
    private String scheduleFullDataHTML = "";
    private String scheduleStartTime = "";
    private String scheduleDesc = "";
    private String isDayTitle = "";
    private String scheduleEndTime = "";
    private Boolean m2pane = false;

    @Override
    public void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);

        if (getArguments().containsKey(SCHEDULETITLE))
        {
            scheduleTitle = getArguments().getString(SCHEDULETITLE);
        }

        if (getArguments().containsKey(SCHEDULEID))
        {
            scheduleID = getArguments().getString(SCHEDULEID);
        }

        if (getArguments().containsKey(SCHEDULEFULLDATAHTML))
        {
            scheduleFullDataHTML = getArguments().getString(SCHEDULEFULLDATAHTML);
        }

        if (getArguments().containsKey(SCHEDULESTARTTIME))
        {
            scheduleStartTime = getArguments().getString(SCHEDULESTARTTIME);
        }

        if (getArguments().containsKey(SCHEDULEDESC))
        {
            scheduleDesc = getArguments().getString(SCHEDULEDESC);
        }

        if (getArguments().containsKey(SCHEDULEENDTIME) && getArguments().getString(SCHEDULEENDTIME) != null && !getArguments().getString(SCHEDULEENDTIME).equals("null"))
        {
            scheduleEndTime = getArguments().getString(SCHEDULEENDTIME);
        }
        else
        {
            scheduleEndTime = "???";
        }

        if (getArguments().containsKey(ARG_2PANE))
        {
            m2pane = getArguments().getBoolean(ARG_2PANE);
        }
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState)
    {
        View rootView = inflater.inflate(R.layout.schedule_detail_fragment,	container, false);


        ((TextView) rootView.findViewById(R.id.times)).setText(scheduleStartTime + " till " + scheduleEndTime);
        ((TextView) rootView.findViewById(R.id.times)).setTypeface(Typeface.create("sans-serif-light", Typeface.NORMAL));

        if(rootView.findViewById(R.id.Title) != null)
        {
            ((TextView) rootView.findViewById(R.id.Title)).setText(scheduleDesc);
            ((TextView) rootView.findViewById(R.id.Title)).setTypeface(Typeface.create("sans-serif-light", Typeface.NORMAL));
            ((TextView) rootView.findViewById(R.id.times)).setTypeface(Typeface.create("sans-serif-condensed", Typeface.NORMAL));
            getActivity().getActionBar().setTitle(scheduleTitle + " - " + getActivity().getString(R.string.app_name));
        }



        TextView fullDetailsTV = (TextView) rootView.findViewById(R.id.fullDetails);

        if(null == scheduleFullDataHTML || scheduleFullDataHTML.equals("") || scheduleFullDataHTML.equals("null"))
        {
            fullDetailsTV.setText(Html.fromHtml(scheduleDesc));
        }
        else
        {
            fullDetailsTV.setText(Html.fromHtml(scheduleFullDataHTML));
        }
        fullDetailsTV.setTypeface(Typeface.create("sans-serif", Typeface.NORMAL));

        try
        {
            fullDetailsTV.setMovementMethod(LinkMovementMethod.getInstance());
        }
        catch (Exception e)
        {
            //Worth a shot
        }
        return rootView;
    }

}
