/*
 * Copyright (C) 2013 - Gareth Llewellyn
 *
 * This file is part of the Unofficial HackedIO Android App https://github.com/NetworksAreMadeOfString/HackedIO-Android-App
 *
 * This app is unofficial. The "Hacked.io" logo is copyright (and maybe even a trademark of) Telefónica UK Limited.
 * The author of this app is not affiliated with Telefónica UK Limited, The Lab ( https://thelab.o2.com/ ) or
 * Geeks of London ( http://geeksoflondon.com/ ) although the author <strong>is</strong> an attendee.
 *
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program. If not, see <http://www.gnu.org/licenses/>
 */
package app.hacked;

import android.content.Context;
import android.graphics.Typeface;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import java.util.List;

public class ScheduleListAdapter extends BaseAdapter
{

    private Context context;
    private List<ScheduleItem> HackedIOSchedule;

    public ScheduleListAdapter(Context context, List<ScheduleItem> HackedIOSchedule)
    {
        this.context = context;
        this.HackedIOSchedule = HackedIOSchedule;
    }

    @Override
    public int getCount()
    {
       return HackedIOSchedule.size();
    }

    @Override
    public Object getItem(int i)
    {
        return HackedIOSchedule.get(i);
    }

    @Override
    public long getItemId(int i)
    {
        return i;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup viewGroup)
    {
        ScheduleItem scheduleItem = HackedIOSchedule.get(position);
        Typeface DayTitle = Typeface.create("sans-serif-thin", Typeface.NORMAL);

        Typeface NormalTitle = Typeface.create("sans-serif-light", Typeface.NORMAL);
        Typeface Normal = Typeface.create("sans-serif", Typeface.NORMAL);

        //if (convertView == null && scheduleItem.isDay)
       //{
            LayoutInflater inflater = (LayoutInflater) context.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
            if(scheduleItem.isDay)
            {
                convertView = inflater.inflate(R.layout.schedule_list_item_title, null);
                TextView dayTitle = (TextView) convertView.findViewById(R.id.DayTitle);
                dayTitle.setTypeface(DayTitle);
                dayTitle.setText(scheduleItem.Title);

                TextView dayDesc = (TextView) convertView.findViewById(R.id.DayDesc);
                dayDesc.setTypeface(Normal);
                dayDesc.setText(scheduleItem.itemDesc);
            }
            else
            {
                convertView = inflater.inflate(R.layout.schedule_list_item, null);

                TextView scheduleTitle = (TextView) convertView.findViewById(R.id.scheduleTitle);
                scheduleTitle.setTypeface(NormalTitle);
                scheduleTitle.setText(scheduleItem.Title);

                TextView scheduleDesc = (TextView) convertView.findViewById(R.id.ScheduleDesc);
                scheduleDesc.setTypeface(Normal);
                scheduleDesc.setText(scheduleItem.itemDesc);
            }
        //}

        return convertView;
    }
}
