package app.hacked;

import android.content.Context;
import android.graphics.Typeface;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;
import com.android.volley.RequestQueue;
import com.android.volley.toolbox.ImageLoader;
import com.android.volley.toolbox.NetworkImageView;
import com.android.volley.toolbox.Volley;

import java.util.ArrayList;

public class TeamMemberGridAdapter extends BaseAdapter
{
    private Context mContext;
    private int imgWidth = 0;
    private int imgHeight = 0;
    public ArrayList<TeamMember> TeamMembers = null;
    private RequestQueue mRequestQueue;
    private ImageLoader mImageLoader;

    public TeamMemberGridAdapter(Context c, ArrayList<TeamMember> team)
    {
        mContext = c;
        TeamMembers = team;
    }

    public int getCount()
    {
        return TeamMembers.size();
    }

    public Object getItem(int position)
    {
        return TeamMembers.get(position);
    }

    public long getItemId(int position)
    {
        return position;
    }

    public View getView(int position, View convertView, ViewGroup parent)
    {
        if(imgWidth == 0)
        {
            imgWidth = (parent.getMeasuredWidth() / mContext.getResources().getInteger(R.integer.GridColumns));
            //imgHeight = (300 * (imgWidth / 500));
        }

        TeamMember teamMember = TeamMembers.get(position);
        if (convertView == null)
        {
            LayoutInflater inflater = (LayoutInflater) mContext.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
            convertView = inflater.inflate(R.layout.project_teammember_grid_item, null);
        }

        if(mRequestQueue == null)
        {
            mRequestQueue = Volley.newRequestQueue(mContext);
        }

        if(mImageLoader == null)
        {
            mImageLoader = new ImageLoader(mRequestQueue, new BitmapLruCache());
        }

        ((TextView) convertView.findViewById(R.id.teamName)).setText(teamMember.Name);
        ((TextView) convertView.findViewById(R.id.teamName)).setTypeface(Typeface.create("sans-serif-condensed", Typeface.NORMAL));

        ((NetworkImageView) convertView.findViewById(R.id.teamGravatar)).setImageUrl(teamMember.GravatarURL + "?d=retro&s="+ Integer.toString(imgWidth),mImageLoader);

        return convertView;
    }
}
